Added some new useragents.
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.3-test"
28 GIT_BRANCH=master:master # Version number
29 SLOGAN="www.ipfire.org" # Software slogan
30 CONFIG_ROOT=/var/ipfire # Configuration rootdir
31 NICE=10 # Nice level
32 MAX_RETRIES=1 # prefetch/check loop
33 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
34 MACHINE=`uname -m`
35 GIT_TAG=$(git tag | tail -1)
36
37 IPFVER="full" # Which versions should be compiled? (full|devel)
38
39 # Debian specific settings
40 if [ ! -e /etc/debian_version ]; then
41 FULLPATH=`which $0`
42 else
43 if [ -x /usr/bin/realpath ]; then
44 FULLPATH=`/usr/bin/realpath $0`
45 else
46 echo "ERROR: Need to do apt-get install realpath"
47 exit 1
48 fi
49 fi
50
51 PWD=`pwd`
52 BASENAME=`basename $0`
53 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
54 LOGFILE=$BASEDIR/log/_build.preparation.log
55 export BASEDIR LOGFILE
56 DIR_CHK=$BASEDIR/cache/check
57 mkdir $BASEDIR/log/ 2>/dev/null
58
59 # Include funtions
60 . tools/make-functions
61
62 if [ -f .config ]; then
63 . .config
64 else
65 echo -e "${BOLD}No configuration found!${NORMAL}"
66 echo -ne "Do you want to create one (y/N)?"
67 read CREATE_CONFIG
68 echo ""
69 if [ "$CREATE_CONFIG" == "y" ]; then
70 make_config
71 fi
72 fi
73
74 if [ -z $EDITOR ]; then
75 for i in nano emacs vi; do
76 EDITOR=$(which $i 2>/dev/null)
77 if ! [ -z $EDITOR ]; then
78 export EDITOR=$EDITOR
79 break
80 fi
81 done
82 [ -z $EDITOR ] && exiterror "You should have installed an editor."
83 fi
84
85 prepareenv() {
86 ############################################################################
87 # #
88 # Are we running the right shell? #
89 # #
90 ############################################################################
91 if [ ! "$BASH" ]; then
92 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
93 fi
94
95 if [ -z "${BASH_VERSION}" ]; then
96 exiterror "Not running BASH shell."
97 fi
98
99
100 ############################################################################
101 # #
102 # Trap on emergency exit #
103 # #
104 ############################################################################
105 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
106
107
108 ############################################################################
109 # #
110 # Resetting our nice level #
111 # #
112 ############################################################################
113 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
114 renice $NICE $$ > /dev/null
115 if [ `nice` != "$NICE" ]; then
116 beautify message FAIL
117 exiterror "Failed to set correct nice level"
118 else
119 beautify message DONE
120 fi
121
122
123 ############################################################################
124 # #
125 # Checking if running as root user #
126 # #
127 ############################################################################
128 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
129 if [ `id -u` != 0 ]; then
130 beautify message FAIL
131 exiterror "Not building as root"
132 else
133 beautify message DONE
134 fi
135
136
137 ############################################################################
138 # #
139 # Checking for necessary temporary space #
140 # #
141 ############################################################################
142 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
143 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
144 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
145 if (( 2048000 > $BASE_ASPACE )); then
146 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
147 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
148 beautify message FAIL
149 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
150 fi
151 else
152 beautify message DONE
153 fi
154
155 ############################################################################
156 # #
157 # Building Linux From Scratch system #
158 # #
159 ############################################################################
160 # Set umask
161 umask 022
162
163 # Set LFS Directory
164 LFS=$BASEDIR/build
165
166 # Check /tools symlink
167 if [ -h /tools ]; then
168 rm -f /tools
169 fi
170 if [ ! -a /tools ]; then
171 ln -s $BASEDIR/build/tools /
172 fi
173 if [ ! -h /tools ]; then
174 exiterror "Could not create /tools symbolic link."
175 fi
176
177 # Setup environment
178 set +h
179 LC_ALL=POSIX
180 MAKETUNING="-j6"
181 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
182 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
183
184 # Make some extra directories
185 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
186 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
187 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
188 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
189
190 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
191 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
192
193 # Make all sources and proc available under lfs build
194 mount --bind /dev $BASEDIR/build/dev
195 mount --bind /dev/pts $BASEDIR/build/dev/pts
196 mount --bind /dev/shm $BASEDIR/build/dev/shm
197 mount --bind /proc $BASEDIR/build/proc
198 mount --bind /sys $BASEDIR/build/sys
199 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
200 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
201 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
202 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
203 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
204 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
205 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
206 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
207 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
208
209 # This is a temporary hack!!!
210 if [ ! -f /tools/bin/hostname ]; then
211 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
212 fi
213
214 # Run LFS static binary creation scripts one by one
215 export CCACHE_DIR=$BASEDIR/ccache
216 export CCACHE_HASHDIR=1
217
218 # Remove pre-install list of installed files in case user erase some files before rebuild
219 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
220 }
221
222 buildtoolchain() {
223 LOGFILE="$BASEDIR/log/_build.toolchain.log"
224 export LOGFILE
225 ORG_PATH=$PATH
226 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
227 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
228 lfsmake1 ccache
229 lfsmake1 binutils PASS=1
230 lfsmake1 gcc PASS=1
231 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
232 lfsmake1 linux-libc-header
233 lfsmake1 glibc
234 lfsmake1 cleanup-toolchain PASS=1
235 lfsmake1 tcl
236 lfsmake1 expect
237 lfsmake1 dejagnu
238 lfsmake1 gcc PASS=2
239 lfsmake1 binutils PASS=2
240 lfsmake1 ncurses
241 lfsmake1 bash
242 lfsmake1 bzip2
243 lfsmake1 coreutils
244 lfsmake1 diffutils
245 lfsmake1 findutils
246 lfsmake1 gawk
247 lfsmake1 gettext
248 lfsmake1 grep
249 lfsmake1 gzip
250 lfsmake1 m4
251 lfsmake1 make
252 lfsmake1 patch
253 lfsmake1 perl
254 lfsmake1 sed
255 lfsmake1 tar
256 lfsmake1 texinfo
257 lfsmake1 util-linux
258 lfsmake1 cleanup-toolchain PASS=2
259 export PATH=$ORG_PATH
260 }
261
262 buildbase() {
263 LOGFILE="$BASEDIR/log/_build.base.log"
264 export LOGFILE
265 lfsmake2 stage2
266 lfsmake2 linux-libc-header
267 lfsmake2 man-pages
268 lfsmake2 glibc
269 lfsmake2 cleanup-toolchain PASS=3
270 lfsmake2 binutils
271 lfsmake2 gcc
272 lfsmake2 berkeley
273 lfsmake2 coreutils
274 lfsmake2 iana-etc
275 lfsmake2 m4
276 lfsmake2 bison
277 lfsmake2 ncurses
278 lfsmake2 procps
279 lfsmake2 sed
280 lfsmake2 libtool
281 lfsmake2 perl
282 lfsmake2 readline
283 lfsmake2 zlib
284 lfsmake2 autoconf
285 lfsmake2 automake
286 lfsmake2 bash
287 lfsmake2 bzip2
288 lfsmake2 diffutils
289 lfsmake2 e2fsprogs
290 lfsmake2 ed
291 lfsmake2 file
292 lfsmake2 findutils
293 lfsmake2 flex
294 lfsmake2 gawk
295 lfsmake2 gettext
296 lfsmake2 grep
297 lfsmake2 groff
298 lfsmake2 gzip
299 lfsmake2 inetutils
300 lfsmake2 iproute2
301 lfsmake2 kbd
302 lfsmake2 less
303 lfsmake2 libaal
304 lfsmake2 make
305 lfsmake2 man
306 lfsmake2 mktemp
307 lfsmake2 modutils
308 lfsmake2 mtd
309 lfsmake2 net-tools
310 lfsmake2 patch
311 lfsmake2 psmisc
312 lfsmake2 reiser4progs
313 lfsmake2 shadow
314 lfsmake2 sysklogd
315 lfsmake2 sysvinit
316 lfsmake2 tar
317 lfsmake2 texinfo
318 lfsmake2 udev
319 lfsmake2 util-linux
320 lfsmake2 vim
321 lfsmake2 grub
322 }
323
324 buildipfire() {
325 LOGFILE="$BASEDIR/log/_build.ipfire.log"
326 export LOGFILE
327 ipfiremake configroot
328 ipfiremake backup
329 ipfiremake dhcp
330 ipfiremake dhcpcd
331 ipfiremake libusb
332 ipfiremake libpcap
333 ipfiremake ppp
334 ipfiremake rp-pppoe
335 ipfiremake unzip
336 # ipfiremake linux SMP=1
337 # ipfiremake linux-fusion SMP=1
338 # ipfiremake ipp2p SMP=1
339 # ipfiremake atl2 SMP=1
340 # ipfiremake kqemu SMP=1
341 # ipfiremake v4l-dvb SMP=1
342 # ipfiremake madwifi SMP=1
343 # ipfiremake alsa KMOD=1 SMP=1
344 # ipfiremake sane KMOD=1 SMP=1
345 # ipfiremake openswan KMOD=1 SMP=1
346 ipfiremake linux
347 ipfiremake linux-fusion
348 ipfiremake atl2
349 ipfiremake r8168
350 ipfiremake r8169
351 ipfiremake kqemu
352 ipfiremake v4l-dvb
353 ipfiremake madwifi
354 ipfiremake alsa KMOD=1
355 ipfiremake sane KMOD=1
356 ipfiremake openswan KMOD=1
357 ipfiremake pkg-config
358 ipfiremake linux-atm
359 ipfiremake cpio
360 ipfiremake klibc
361 ipfiremake mkinitcpio
362 ipfiremake udev KLIBC=1
363 ipfiremake expat
364 ipfiremake gdbm
365 ipfiremake gmp
366 ipfiremake pam
367 ipfiremake openssl
368 ipfiremake curl
369 ipfiremake python
370 ipfiremake libnet
371 ipfiremake libidn
372 ipfiremake libjpeg
373 ipfiremake libpng
374 ipfiremake libtiff
375 ipfiremake libart
376 ipfiremake freetype
377 ipfiremake gd
378 ipfiremake popt
379 ipfiremake pcre
380 ipfiremake slang
381 ipfiremake newt
382 ipfiremake libcap
383 ipfiremake pciutils
384 ipfiremake usbutils
385 ipfiremake libxml2
386 ipfiremake libxslt
387 ipfiremake BerkeleyDB
388 ipfiremake mysql
389 ipfiremake cyrus-sasl
390 ipfiremake openldap
391 ipfiremake apache2
392 ipfiremake php
393 ipfiremake apache2 PASS=C
394 ipfiremake arping
395 ipfiremake beep
396 ipfiremake bind
397 ipfiremake cdrtools
398 ipfiremake dnsmasq
399 ipfiremake dosfstools
400 ipfiremake squashfstools
401 ipfiremake reiserfsprogs
402 ipfiremake xfsprogs
403 ipfiremake sysfsutils
404 ipfiremake fuse
405 ipfiremake ntfs-3g
406 ipfiremake ethtool
407 ipfiremake ez-ipupdate
408 ipfiremake fcron
409 ipfiremake perl-GD
410 ipfiremake GD-Graph
411 ipfiremake GD-TextUtil
412 ipfiremake gnupg
413 ipfiremake hdparm
414 ipfiremake sdparm
415 ipfiremake mtools
416 ipfiremake initscripts
417 ipfiremake whatmask
418 ipfiremake iptables
419 ipfiremake libupnp
420 ipfiremake linux-igd
421 ipfiremake ipaddr
422 ipfiremake iptstate
423 ipfiremake iputils
424 ipfiremake l7-protocols
425 ipfiremake mISDN
426 ipfiremake capi4k-utils
427 ipfiremake hwdata
428 ipfiremake kudzu
429 ipfiremake logrotate
430 ipfiremake logwatch
431 ipfiremake misc-progs
432 ipfiremake nano
433 ipfiremake nasm
434 ipfiremake URI
435 ipfiremake HTML-Tagset
436 ipfiremake HTML-Parser
437 ipfiremake Compress-Zlib
438 ipfiremake Digest
439 ipfiremake Digest-SHA1
440 ipfiremake Digest-HMAC
441 ipfiremake libwww-perl
442 ipfiremake Net-DNS
443 ipfiremake Net-IPv4Addr
444 ipfiremake Net_SSLeay
445 ipfiremake IO-Stringy
446 ipfiremake Unix-Syslog
447 ipfiremake Mail-Tools
448 ipfiremake MIME-Tools
449 ipfiremake Net-Server
450 ipfiremake Convert-TNEF
451 ipfiremake Convert-UUlib
452 ipfiremake Archive-Tar
453 ipfiremake Archive-Zip
454 ipfiremake Text-Tabs+Wrap
455 ipfiremake Locale-Country
456 ipfiremake XML-Parser
457 ipfiremake python-setuptools
458 ipfiremake python-clientform
459 ipfiremake python-mechanize
460 ipfiremake python-feedparser
461 ipfiremake python-rssdler
462 ipfiremake glib
463 ipfiremake GeoIP
464 ipfiremake fwhits
465 ipfiremake noip_updater
466 ipfiremake ntp
467 ipfiremake openssh
468 ipfiremake rrdtool
469 ipfiremake setserial
470 ipfiremake setup
471 ipfiremake snort
472 ipfiremake oinkmaster
473 ipfiremake squid
474 ipfiremake squidguard
475 ipfiremake calamaris
476 ipfiremake tcpdump
477 ipfiremake traceroute
478 ipfiremake vlan
479 ipfiremake wireless
480 ipfiremake libsafe
481 ipfiremake pakfire
482 ipfiremake java
483 ipfiremake spandsp
484 ipfiremake lzo
485 ipfiremake openvpn
486 ipfiremake pammysql
487 ipfiremake cups
488 ipfiremake ghostscript
489 ipfiremake foomatic
490 ipfiremake hplip
491 ipfiremake samba
492 ipfiremake sudo
493 ipfiremake mc
494 ipfiremake wget
495 ipfiremake bridge-utils
496 ipfiremake screen
497 ipfiremake hddtemp
498 ipfiremake smartmontools
499 ipfiremake htop
500 ipfiremake postfix
501 ipfiremake fetchmail
502 ipfiremake cyrus-imapd
503 ipfiremake openmailadmin
504 ipfiremake clamav
505 ipfiremake spamassassin
506 ipfiremake amavisd
507 ipfiremake alsa
508 ipfiremake mpfire
509 ipfiremake guardian
510 ipfiremake libid3tag
511 ipfiremake libmad
512 ipfiremake libogg
513 ipfiremake libvorbis
514 ipfiremake libdvbpsi
515 ipfiremake lame
516 ipfiremake sox
517 ipfiremake libshout
518 ipfiremake icecast
519 ipfiremake icegenerator
520 ipfiremake mpd
521 ipfiremake mpc
522 ipfiremake xvid
523 ipfiremake libmpeg2
524 ipfiremake cmake
525 ipfiremake libpri
526 ipfiremake asterisk
527 ipfiremake gnump3d
528 ipfiremake libsigc++
529 ipfiremake applejuice
530 ipfiremake ocaml
531 ipfiremake mldonkey
532 ipfiremake libtorrent
533 ipfiremake rtorrent
534 ipfiremake ipfireseeder
535 ipfiremake rsync
536 ipfiremake tcpwrapper
537 ipfiremake portmap
538 ipfiremake nfs
539 ipfiremake nmap
540 ipfiremake ncftp
541 ipfiremake etherwake
542 ipfiremake bwm-ng
543 ipfiremake tripwire
544 ipfiremake sysstat
545 ipfiremake vsftpd
546 ipfiremake which
547 ipfiremake openswan
548 ipfiremake lsof
549 ipfiremake centerim
550 ipfiremake br2684ctl
551 ipfiremake pcmciautils
552 ipfiremake lm_sensors
553 ipfiremake collectd
554 ipfiremake lcd4linux
555 ipfiremake tcptrack
556 ipfiremake teamspeak
557 ipfiremake elinks
558 ipfiremake igmpproxy
559 ipfiremake fbset
560 ipfiremake sdl
561 ipfiremake qemu
562 ipfiremake sane
563 ipfiremake netpbm
564 ipfiremake phpSANE
565 ipfiremake tunctl
566 ipfiremake nagios
567 ipfiremake ebtables
568 ipfiremake fontconfig
569 ipfiremake freefont
570 ipfiremake directfb
571 ipfiremake dfb++
572 ipfiremake ffmpeg
573 ipfiremake videolan
574 ipfiremake vdr
575 ipfiremake w_scan
576 ipfiremake git
577 ipfiremake squidclamav
578 ipfiremake bc
579 ipfiremake esniper
580 ipfiremake vnstat
581 ipfiremake vnstati
582 ipfiremake wpa_supplicant
583 ipfiremake hostapd
584 ipfiremake urlgrabber
585 ipfiremake syslinux
586 ipfiremake tftp-hpa
587 ipfiremake cpufrequtils
588 ipfiremake dbus
589 ipfiremake bluetooth
590 ipfiremake gutenprint
591 ipfiremake apcupsd
592 ipfiremake iperf
593 ipfiremake netcat
594 echo Build on $HOSTNAME > $BASEDIR/build/var/ipfire/firebuild
595 cat /proc/version >> $BASEDIR/build/var/ipfire/firebuild
596 echo >> $BASEDIR/build/var/ipfire/firebuild
597 git log -1 >> $BASEDIR/build/var/ipfire/firebuild
598 echo >> $BASEDIR/build/var/ipfire/firebuild
599 git status >> $BASEDIR/build/var/ipfire/firebuild
600 echo >> $BASEDIR/build/var/ipfire/firebuild
601 cat /proc/cpuinfo >> $BASEDIR/build/var/ipfire/firebuild
602 }
603
604 buildinstaller() {
605 # Run installer scripts one by one
606 LOGFILE="$BASEDIR/log/_build.installer.log"
607 export LOGFILE
608 ipfiremake as86
609 ipfiremake mbr
610 ipfiremake memtest
611 installmake linux-libc-header
612 installmake binutils
613 ipfiremake uClibc PASS=1
614 ipfiremake gcc INST=1
615 installmake uClibc PASS=2
616 installmake gcc INST=2
617 installmake uClibc PASS=3
618 installmake busybox
619 installmake udev
620 installmake slang
621 installmake newt
622 installmake gettext
623 installmake kbd
624 installmake popt
625 installmake sysvinit
626 installmake misc-progs
627 installmake libaal
628 installmake reiser4progs
629 installmake reiserfsprogs
630 installmake sysfsutils
631 installmake util-linux
632 installmake pciutils
633 installmake zlib
634 installmake mtd
635 installmake wget
636 installmake hwdata
637 installmake kudzu
638 installmake pcmciautils
639 installmake installer
640 installmake initrd
641 }
642
643 buildpackages() {
644 LOGFILE="$BASEDIR/log/_build.packages.log"
645 export LOGFILE
646 echo "... see detailed log in _build.*.log files" >> $LOGFILE
647
648 installmake strip
649
650 # Generating list of packages used
651 echo -n "Generating packages list from logs" | tee -a $LOGFILE
652 rm -f $BASEDIR/doc/packages-list
653 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
654 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
655 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
656 fi
657 done
658 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
659 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
660 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
661 rm -f $BASEDIR/doc/packages-list
662 # packages-list.txt is ready to be displayed for wiki page
663 beautify message DONE
664
665 # Update changelog
666 cd $BASEDIR
667 $0 git log
668
669 # Create images for install
670 ipfiremake cdrom ED=full
671
672 # Check if there is a loop device for building in virtual environments
673 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
674 ipfiremake usb-stick
675 fi
676
677 # Create updater package
678 ipfiremake updater
679 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
680
681 ipfirepackages
682
683 # Cleanup
684 stdumount
685 rm -rf $BASEDIR/build/tmp/*
686
687 # Generating total list of files
688 echo -n "Generating files list from logs" | tee -a $LOGFILE
689 rm -f $BASEDIR/log/FILES
690 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
691 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
692 echo "##" >>$BASEDIR/log/FILES
693 echo "## `basename $i`" >>$BASEDIR/log/FILES
694 echo "##" >>$BASEDIR/log/FILES
695 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
696 fi
697 done
698 beautify message DONE
699
700 cd $PWD
701 }
702
703 ipfirepackages() {
704 ipfiremake core-updates
705 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
706 if [ -e $BASEDIR/lfs/$i ]; then
707 ipfiredist $i
708 else
709 echo -n $i
710 beautify message SKIP
711 fi
712 done
713 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
714 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
715 rm -rf $BASEDIR/build/install/packages/*
716 }
717
718 # See what we're supposed to do
719 case "$1" in
720 build)
721 clear
722 BUILDMACHINE=`uname -m`
723 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
724 #only restore on a clean disk
725 if [ ! -f log/cleanup-toolchain-2-tools ]; then
726 if [ ! -n "$PACKAGE" ]; then
727 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
728 prepareenv
729 buildtoolchain
730 else
731 PACKAGENAME=${PACKAGE%.tar.gz}
732 beautify build_stage "Packaged toolchain compilation"
733 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
734 tar zxf $PACKAGE
735 prepareenv
736 else
737 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
738 fi
739 fi
740 else
741 echo -n "Using installed toolchain" | tee -a $LOGFILE
742 beautify message SKIP
743 prepareenv
744 fi
745
746 beautify build_start
747 beautify build_stage "Building LFS"
748 buildbase
749
750 beautify build_stage "Building IPFire"
751 buildipfire
752
753 beautify build_stage "Building installer"
754 buildinstaller
755
756 beautify build_stage "Building packages"
757 buildpackages
758
759 beautify build_stage "Checking Logfiles for new Files"
760 cd ..
761 tools/checknewlog.pl
762
763 beautify build_end
764 ;;
765 shell)
766 # enter a shell inside LFS chroot
767 # may be used to changed kernel settings
768 prepareenv
769 entershell
770 ;;
771 clean)
772 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
773 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
774 $LOSETUP -d $i 2>/dev/null
775 done
776 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
777 umount $i
778 done
779 stdumount
780 for i in `seq 0 7`; do
781 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
782 umount /dev/loop${i} 2>/dev/null;
783 losetup -d /dev/loop${i} 2>/dev/null;
784 fi;
785 done
786 rm -rf $BASEDIR/build
787 rm -rf $BASEDIR/cdrom
788 rm -rf $BASEDIR/packages
789 rm -rf $BASEDIR/log
790 if [ -h /tools ]; then
791 rm -f /tools
792 fi
793 beautify message DONE
794 ;;
795 downloadsrc)
796 if [ ! -d $BASEDIR/cache ]; then
797 mkdir $BASEDIR/cache
798 fi
799 mkdir -p $BASEDIR/log
800 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
801 FINISHED=0
802 cd $BASEDIR/lfs
803 for c in `seq $MAX_RETRIES`; do
804 if (( FINISHED==1 )); then
805 break
806 fi
807 FINISHED=1
808 cd $BASEDIR/lfs
809 for i in *; do
810 if [ -f "$i" -a "$i" != "Config" ]; then
811 echo -ne "Loading $i"
812 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
813 if [ $? -ne 0 ]; then
814 beautify message FAIL
815 FINISHED=0
816 else
817 if [ $c -eq 1 ]; then
818 beautify message DONE
819 fi
820 fi
821 fi
822 done
823 done
824 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
825 ERROR=0
826 for i in *; do
827 if [ -f "$i" -a "$i" != "Config" ]; then
828 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
829 if [ $? -ne 0 ]; then
830 echo -ne "MD5 difference in lfs/$i"
831 beautify message FAIL
832 ERROR=1
833 fi
834 fi
835 done
836 if [ $ERROR -eq 0 ]; then
837 echo -ne "${BOLD}all files md5sum match${NORMAL}"
838 beautify message DONE
839 else
840 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
841 beautify message FAIL
842 fi
843 cd - >/dev/null 2>&1
844 ;;
845 toolchain)
846 clear
847 prepareenv
848 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
849 buildtoolchain
850 BUILDMACHINE=`uname -m`
851 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
852 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
853 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
854 build/{bin,etc,usr/bin,usr/local} \
855 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
856 log >> $LOGFILE
857 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
858 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
859 stdumount
860 ;;
861 gettoolchain)
862 BUILDMACHINE=`uname -m`
863 # arbitrary name to be updated in case of new toolchain package upload
864 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
865 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
866 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
867 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
868 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
869 cd $BASEDIR/cache/toolchains
870 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
871 if [ $? -ne 0 ]; then
872 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
873 else
874 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
875 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
876 else
877 exiterror "$PACKAGE.md5 did not match, check downloaded package"
878 fi
879 fi
880 else
881 echo "Toolchain is already downloaded. Exiting..."
882 fi
883 ;;
884 othersrc)
885 prepareenv
886 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
887 chroot $LFS /tools/bin/env -i HOME=/root \
888 TERM=$TERM PS1='\u:\w\$ ' \
889 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
890 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
891 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
892 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
893 if [ $? -eq "0" ]; then
894 beautify message DONE
895 else
896 beautify message FAIL
897 fi
898 stdumount
899 ;;
900 git)
901 case "$2" in
902 update|up)
903 git pull
904 ;;
905 commit|ci)
906 shift 2
907 git commit $*
908
909 [ "$?" -eq "0" ] || exiterror "git commit $* failed."
910
911 echo -e "${BOLD}Do you want to push, too? [y/N]${NORMAL}"
912 read
913 [ -z $REPLY ] && exit 0
914 for i in y Y j J; do
915 if [ "$i" == "$REPLY" ]; then
916 $0 git push
917 exit $?
918 fi
919 done
920 exiterror "\"$REPLY\" is not a valid answer."
921 ;;
922 dist)
923 git archive HEAD | gzip -9 > ${SNAME}-${VERSION}.tar.gz
924 ;;
925 diff|di)
926 echo -ne "Make a local diff to last revision"
927 git diff HEAD > ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff
928 evaluate 1
929 echo "Diff was successfully saved to ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff"
930 git diff --stat
931 ;;
932 push)
933 [ -z $GIT_USER ] && exiterror "You have to setup GIT_USER first."
934 GIT_URL="ssh://${GIT_USER}@git.ipfire.org/pub/git/ipfire-2.x"
935
936 git push ${GIT_URL} ${GIT_BRANCH}
937 ;;
938 log)
939 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
940 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
941
942 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
943 ;;
944 esac
945 ;;
946 uploadsrc)
947 PWD=`pwd`
948 cd $BASEDIR/cache/
949 echo -e "Uploading cache to ftp server:"
950 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
951 for i in *; do
952 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
953 grep -q $(basename $i) /tmp/ftplist
954 if [ "$?" -ne "0" ]; then
955 echo -ne "$(basename $i)"
956 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
957 if [ "$?" -ne "0" ]; then
958 beautify message FAIL
959 fi
960 fi
961 done
962 rm -f /tmp/ftplist
963 cd $PWD
964 exit 0
965 ;;
966 upload)
967 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
968 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
969 if [ -z $FTP_ISO_PORT ]; then
970 FTP_ISO_PORT=21
971 fi
972 cat <<EOF > .ftp-commands
973 mkdir -p $FTP_ISO_PATH$SVN_REVISION
974 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
975 quit
976 EOF
977 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
978 rm -f .ftp-commands
979
980 case "$2" in
981 iso)
982 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
983
984 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
985 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
986 if [ -e "$i" ]; then
987 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
988 if [ "$?" -eq "0" ]; then
989 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
990 else
991 echo "There was an error while uploading the file $i to the ftp server."
992 exit 1
993 fi
994 fi
995 done
996 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
997 if [ "$3" = "--with-sources-cd" ]; then
998 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
999 fi
1000 ;;
1001 paks)
1002 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
1003 if [ "$?" -eq "0" ]; then
1004 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
1005 else
1006 echo -e "There was an error while uploading the packages to the ftp server."
1007 exit 1
1008 fi
1009 ;;
1010 esac
1011 ;;
1012 batch)
1013 if [ "$2" = "--background" ]; then
1014 batch_script
1015 exit $?
1016 fi
1017 if [ `screen -ls | grep -q ipfire` ]; then
1018 echo "Build is already running, sorry!"
1019 exit 1
1020 else
1021 if [ "$2" = "--rebuild" ]; then
1022 export IPFIRE_REBUILD=1
1023 echo "REBUILD!"
1024 else
1025 export IPFIRE_REBUILD=0
1026 fi
1027 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1028 screen -dmS ipfire $0 batch --background
1029 evaluate 1
1030 exit 0
1031 fi
1032 ;;
1033 watch)
1034 watch_screen
1035 ;;
1036 pxe)
1037 case "$2" in
1038 start)
1039 start_tftpd
1040 ;;
1041 stop)
1042 stop_tftpd
1043 ;;
1044 reload|restart)
1045 reload_tftpd
1046 ;;
1047 esac
1048 exit 0
1049 ;;
1050 lang)
1051 update_langs
1052 ;;
1053 "")
1054 clear
1055 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "LOG: Tail" "Help"
1056 do
1057 case $name in
1058 "IPFIRE: Downloadsrc")
1059 $0 downloadsrc
1060 ;;
1061 "IPFIRE: Build (silent)")
1062 $0 build-silent
1063 ;;
1064 "IPFIRE: Watch Build")
1065 $0 watch
1066 ;;
1067 "IPFIRE: Batch")
1068 $0 batch
1069 ;;
1070 "IPFIRE: Clean")
1071 $0 clean
1072 ;;
1073 "Help")
1074 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1075 cat doc/make.sh-usage
1076 ;;
1077 "LOG: Tail")
1078 tail -f log/_*
1079 ;;
1080 "Exit")
1081 break
1082 ;;
1083 esac
1084 done
1085 ;;
1086 config)
1087 make_config
1088 ;;
1089 *)
1090 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1091 cat doc/make.sh-usage
1092 ;;
1093 esac